package syscon.arbutus.product.services.legal.contract.dto.ordersentence;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * SupervisionSentenceType -- Supervision Level's sentences. Generated by Sentence Calculation Engine.
 * <p>Not able to be updated or deleted, therefore, there is no 'REQUIRED/OPTIONAL' defined in this type.
 *
 * @author yshang
 * @since Jan 06, 2014
 */
public class SupervisionSentenceType implements Serializable {

    private static final long serialVersionUID = 1174423174187874137L;

    /**
     * supervisionSentenceId Id of Supervision Sentence, system generated
     */
    private Long supervisionSentenceId;

    /**
     * supervisionId Supervision Id
     */
    private Long supervisionId;

    /**
     * sentenceStartDate Sentence Start Date
     */
    private Date sentenceStartDate;

    /**
     * paroleEligibilityDate Parole Eligibility Date
     */
    private Date paroleEligibilityDate;

    /**
     * probableDischargeDate Probable Discharge Date
     */
    private Date probableDischargeDate;

    /**
     * sentenceExpiryDate Sentence Expiry Date
     */
    private Date sentenceExpiryDate;

    /**
     * goodTime Sentence adjustment type: GT(Good Time)
     */
    private Long goodTime;

    /**
     * sentenceDays days Sentenced
     */
    private Long sentenceDays;

    /**
     * daysToServe Days to serve for the supervision
     */
    private Long daysToServe;

    /**
     * isHistory True: history record; False: current instance
     */
    private Boolean isHistory;

    /**
     * keyDateHistoryId Id of KeyDates history
     */
    private Long keyDateHistoryId;

    /**
     * List of Aggregate Sentence
     */
    private List<AggregateSentenceGroupType> aggregateSentenceGroups;

    /**
     * Constructor
     */
    public SupervisionSentenceType() {
        super();
    }

    /**
     * getSupervisionSentenceId
     * <p>Identification of Supervision Sentence, system generated;
     *
     * @return the supervisionSentenceId
     */
    public Long getSupervisionSentenceId() {
        return supervisionSentenceId;
    }

    /**
     * setSupervisionSentenceId
     * <p>Identification of Supervision Sentence, system generated;
     *
     * @param supervisionSentenceId the supervisionSentenceId to set
     */
    public void setSupervisionSentenceId(Long supervisionSentenceId) {
        this.supervisionSentenceId = supervisionSentenceId;
    }

    /**
     * getSupervisionId
     * <p>Supervision Id
     *
     * @return the supervisionId
     */
    public Long getSupervisionId() {
        return supervisionId;
    }

    /**
     * setSupervisionId
     * <p>Supervision Id
     *
     * @param supervisionId the supervisionId to set
     */
    public void setSupervisionId(Long supervisionId) {
        this.supervisionId = supervisionId;
    }

    /**
     * getSentenceStartDate
     * <p>Sentence Start Date
     *
     * @return the sentenceStartDate
     */
    public Date getSentenceStartDate() {
        return sentenceStartDate;
    }

    /**
     * setSentenceStartDate
     * <p>Sentence Start Date
     *
     * @param sentenceStartDate the sentenceStartDate to set
     */
    public void setSentenceStartDate(Date sentenceStartDate) {
        this.sentenceStartDate = sentenceStartDate;
    }

    /**
     * getParoleEligibilityDate
     * <p>Parole Eligibility Date
     *
     * @return the paroleEligibilityDate
     */
    public Date getParoleEligibilityDate() {
        return paroleEligibilityDate;
    }

    /**
     * setParoleEligibilityDate
     * <p>Parole Eligibility Date
     *
     * @param paroleEligibilityDate the paroleEligibilityDate to set
     */
    public void setParoleEligibilityDate(Date paroleEligibilityDate) {
        this.paroleEligibilityDate = paroleEligibilityDate;
    }

    /**
     * getProbableDischargeDate
     * <p>Probable Discharge Date
     *
     * @return the probableDischargeDate
     */
    public Date getProbableDischargeDate() {
        return probableDischargeDate;
    }

    /**
     * setProbableDischargeDate
     * <p>Probable Discharge Date
     *
     * @param probableDischargeDate the probableDischargeDate to set
     */
    public void setProbableDischargeDate(Date probableDischargeDate) {
        this.probableDischargeDate = probableDischargeDate;
    }

    /**
     * getSentenceExpiryDate
     * <p>Sentence Expire Date
     *
     * @return the sentenceExpiryDate
     */
    public Date getSentenceExpiryDate() {
        return sentenceExpiryDate;
    }

    /**
     * setSentenceExpiryDate
     * <p>Sentence Expire Date
     *
     * @param sentenceExpiryDate the sentenceExpiryDate to set
     */
    public void setSentenceExpiryDate(Date sentenceExpiryDate) {
        this.sentenceExpiryDate = sentenceExpiryDate;
    }

    /**
     * getGoodTime
     * <p>Good Time -- Sentence adjustment type: GT(Good Time)
     *
     * @return the goodTime
     */
    public Long getGoodTime() {
        return goodTime;
    }

    /**
     * setGoodTime
     * <p>Good Time -- Sentence adjustment type: GT(Good Time)
     *
     * @param goodTime the goodTime to set
     */
    public void setGoodTime(Long goodTime) {
        this.goodTime = goodTime;
    }

    /**
     * getSentenceDays
     * <p>Days sentenced
     *
     * @return the sentenceDays
     */
    public Long getSentenceDays() {
        return sentenceDays;
    }

    /**
     * setSentenceDays
     * <p>Days sentenced
     *
     * @param sentenceDays the sentenceDays to set
     */
    public void setSentenceDays(Long sentenceDays) {
        this.sentenceDays = sentenceDays;
    }

    /**
     * getDaysToServe
     * <p>Days left to serve compare to today
     *
     * @return the daysToServe
     */
    public Long getDaysToServe() {
        return daysToServe;
    }

    /**
     * setDaysToServe
     * <p>Days left to serve compare to today
     *
     * @param daysToServe the daysToServe to set
     */
    public void setDaysToServe(Long daysToServe) {
        this.daysToServe = daysToServe;
    }

    /**
     * getIsHistory
     * <p>History flag: True--history record;False--current record.
     *
     * @return the isHistory
     */
    public Boolean getIsHistory() {
        return isHistory;
    }

    /**
     * setIsHistory
     * <p>History flag: True--history record;False--current record.
     *
     * @param isHistory the isHistory to set
     */
    public void setIsHistory(Boolean isHistory) {
        this.isHistory = isHistory;
    }

    /**
     * getKeyDateHistoryId
     * <p>Identification of Key Date History record.
     *
     * @return the keyDateHistoryId
     */
    public Long getKeyDateHistoryId() {
        return keyDateHistoryId;
    }

    /**
     * setKeyDateHistoryId
     * <p>Identification of Key Date History record.
     *
     * @param keyDateHistoryId the keyDateHistoryId to set
     */
    public void setKeyDateHistoryId(Long keyDateHistoryId) {
        this.keyDateHistoryId = keyDateHistoryId;
    }

    /**
     * getAggregateSentenceGroups
     * <p>List of Aggregate Sentence Group
     *
     * @return the aggregateSentenceGroups
     */
    public List<AggregateSentenceGroupType> getAggregateSentenceGroups() {
        return aggregateSentenceGroups;
    }

    /**
     * setAggregateSentenceGroups
     * <p>List of Aggregate Sentence Group
     *
     * @param aggregateSentenceGroups the aggregateSentenceGroups to set
     */
    public void setAggregateSentenceGroups(List<AggregateSentenceGroupType> aggregateSentenceGroups) {
        this.aggregateSentenceGroups = aggregateSentenceGroups;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((aggregateSentenceGroups == null) ? 0 : aggregateSentenceGroups.hashCode());
        result = prime * result + ((daysToServe == null) ? 0 : daysToServe.hashCode());
        result = prime * result + ((goodTime == null) ? 0 : goodTime.hashCode());
        result = prime * result + ((isHistory == null) ? 0 : isHistory.hashCode());
        result = prime * result + ((keyDateHistoryId == null) ? 0 : keyDateHistoryId.hashCode());
        result = prime * result + ((paroleEligibilityDate == null) ? 0 : paroleEligibilityDate.hashCode());
        result = prime * result + ((probableDischargeDate == null) ? 0 : probableDischargeDate.hashCode());
        result = prime * result + ((sentenceDays == null) ? 0 : sentenceDays.hashCode());
        result = prime * result + ((sentenceExpiryDate == null) ? 0 : sentenceExpiryDate.hashCode());
        result = prime * result + ((sentenceStartDate == null) ? 0 : sentenceStartDate.hashCode());
        result = prime * result + ((supervisionId == null) ? 0 : supervisionId.hashCode());
        result = prime * result + ((supervisionSentenceId == null) ? 0 : supervisionSentenceId.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        SupervisionSentenceType other = (SupervisionSentenceType) obj;
        if (aggregateSentenceGroups == null) {
            if (other.aggregateSentenceGroups != null) {
				return false;
			}
        } else if (!aggregateSentenceGroups.equals(other.aggregateSentenceGroups)) {
			return false;
		}
        if (daysToServe == null) {
            if (other.daysToServe != null) {
				return false;
			}
        } else if (!daysToServe.equals(other.daysToServe)) {
			return false;
		}
        if (goodTime == null) {
            if (other.goodTime != null) {
				return false;
			}
        } else if (!goodTime.equals(other.goodTime)) {
			return false;
		}
        if (isHistory == null) {
            if (other.isHistory != null) {
				return false;
			}
        } else if (!isHistory.equals(other.isHistory)) {
			return false;
		}
        if (keyDateHistoryId == null) {
            if (other.keyDateHistoryId != null) {
				return false;
			}
        } else if (!keyDateHistoryId.equals(other.keyDateHistoryId)) {
			return false;
		}
        if (paroleEligibilityDate == null) {
            if (other.paroleEligibilityDate != null) {
				return false;
			}
        } else if (!paroleEligibilityDate.equals(other.paroleEligibilityDate)) {
			return false;
		}
        if (probableDischargeDate == null) {
            if (other.probableDischargeDate != null) {
				return false;
			}
        } else if (!probableDischargeDate.equals(other.probableDischargeDate)) {
			return false;
		}
        if (sentenceDays == null) {
            if (other.sentenceDays != null) {
				return false;
			}
        } else if (!sentenceDays.equals(other.sentenceDays)) {
			return false;
		}
        if (sentenceExpiryDate == null) {
            if (other.sentenceExpiryDate != null) {
				return false;
			}
        } else if (!sentenceExpiryDate.equals(other.sentenceExpiryDate)) {
			return false;
		}
        if (sentenceStartDate == null) {
            if (other.sentenceStartDate != null) {
				return false;
			}
        } else if (!sentenceStartDate.equals(other.sentenceStartDate)) {
			return false;
		}
        if (supervisionId == null) {
            if (other.supervisionId != null) {
				return false;
			}
        } else if (!supervisionId.equals(other.supervisionId)) {
			return false;
		}
        if (supervisionSentenceId == null) {
            if (other.supervisionSentenceId != null) {
				return false;
			}
        } else if (!supervisionSentenceId.equals(other.supervisionSentenceId)) {
			return false;
		}
        return true;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "SupervisionSentenceType [supervisionSentenceId=" + supervisionSentenceId + ", supervisionId=" + supervisionId + ", sentenceStartDate=" + sentenceStartDate
                + ", paroleEligibilityDate=" + paroleEligibilityDate + ", probableDischargeDate=" + probableDischargeDate + ", sentenceExpiryDate=" + sentenceExpiryDate
                + ", goodTime=" + goodTime + ", sentenceDays=" + sentenceDays + ", daysToServe=" + daysToServe + ", isHistory=" + isHistory + ", keyDateHistoryId="
                + keyDateHistoryId + ", aggregateSentenceGroups=" + aggregateSentenceGroups + "]";
    }

}
